﻿# Read the data from file
run10ind <- read.delim("ind10.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run15ind <- read.delim("ind15.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run20ind <- read.delim("ind20.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run25ind <- read.delim("ind25.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run30ind <- read.delim("ind30.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))


run2cross <- read.delim("cross2.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run4cross <- read.delim("cross4.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run5cross <- read.delim("cross5.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))


run20blokk <- read.delim("bl20.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run40blokk <- read.delim("bl40.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run60blokk <- read.delim("bl60.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run100blokk <- read.delim("bl100.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run120blokk <- read.delim("bl120.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))


run01mut <- read.delim("mut01.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run03mut <- read.delim("mut03.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run07mut <- read.delim("mut07.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))
run09mut <- read.delim("mut09.results",sep="|",colClasses=c("NULL",NA,NA,"NULL","NULL",NA,NA,NA,NA,NA,"NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL",NA,"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"))

#Load functions and generate plots
source("my_functions.R")

ps.options(pointsize=16)

indFitness <- c(run10ind$fitness, run15ind$fitness,
                run20ind$fitness, run25ind$fitness,
                run30ind$fitness)
indTFitness <- c(run10ind$t_fitness, run15ind$t_fitness,
                 run20ind$t_fitness, run25ind$t_fitness,
                 run30ind$t_fitness)
indRel <- c(run10ind$reliability, run15ind$reliability,
            run20ind$reliability, run25ind$reliability,
            run30ind$reliability)
                      
indTRel <- c(run10ind$t_reliability, run15ind$t_reliability,
             run20ind$t_reliability, run25ind$t_reliability,
             run30ind$t_reliability)

tmrR <-
  c(0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093)

enkelR <- c(0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0)


ind <- c(10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
         15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
         20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
         25, 25, 25, 25, 25, 25, 25, 25, 25, 25,
         30, 30, 30, 30, 30, 30, 30, 30, 30, 30)

postscript(file="indFit.ps",onefile=F)
plot(indFitness, ind, xlab="Antall individer",ylab="Egnethet",col="blue",pch=1,xlim =c(10, 30), ylim=c(-2.5, 1),type="n")
avgline2(ind, indFitness,"blue",1)
maxpoints(ind, indFitness,"blue",1)
minpoints(ind, indFitness,"blue",1)
avgline2(ind, indTFitness,"orange",2)
maxpoints(ind, indTFitness,"orange",2)
minpoints(ind, indTFitness,"orange",2)
legend(10,1,c("Egnethet med inverteringsfeil","Egnethet uten inverteringsfeil"),pch=c(1,2),col=c("blue","orange"))
dev.off()

postscript(file="indRel.ps",onefile=F)
plot(indFitness, ind, xlab="Antall individer",ylab="Pålitlighet",col="blue",pch=1,xlim =c(10, 30), ylim=c(0, 1.5),type="n")
avgline2(ind, indRel,"red",1)
maxpoints(ind, indRel,"red",1)
minpoints(ind, indRel,"red",1)
avgline2(ind, indTRel,"green",2)
maxpoints(ind, indTRel,"green",2)
minpoints(ind, indTRel,"green",2)
avgline2(ind, tmrR,"turquoise",3)
maxpoints(ind, tmrR,"turquoise",3)
minpoints(ind, tmrR,"turquoise",3)
avgline2(ind, enkelR,"purple",4)
maxpoints(ind, enkelR,"purple",4)
minpoints(ind, enkelR,"purple",4)
legend(10,1.5,c("Pålitlighet med inverteringsfeil","Pålitlighet uten inverteringsfeil","Pålitlighet av TMR-krets med inverteringsfeil","Pålitlighet av enkel multiplikator med inverteringsfeil"),pch=c(1,2,3,4),col=c("red","green","turquoise","purple"))
dev.off()

crossFit <- c(run2cross$fitness, run20ind$fitness,
              run4cross$fitness, run5cross$fitness)
crossTFit <- c(run2cross$t_fitness, run20ind$t_fitness,
               run4cross$t_fitness, run5cross$t_fitness)
crossRel <- c(run2cross$reliability, run20ind$reliability,
              run4cross$reliability, run5cross$reliability)
crossTRel <- c(run2cross$t_reliability, run20ind$t_reliability,
               run4cross$t_reliability, run5cross$t_reliability)

tmrR <-
  c(0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093)

enkelR <- c(0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0)

cross <- c(0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2, 0.2,
           0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 
           0.4, 0.4, 0.4, 0.4, 0.4, 0.4, 0.4, 0.4, 0.4, 0.4, 
           0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5)

postscript(file="crossFit.ps",onefile=F)
plot(crossFit,cross,xlab="Sannsynlighet for krysning",ylab="Egnethet",col="blue",pch=1,xlim=c(0.2,0.5), ylim=c(-2.5,1),type="n")
avgline2(cross,crossFit,"blue",1)
maxpoints(cross,crossFit,"blue",1)
minpoints(cross,crossFit,"blue",1)
avgline2(cross,crossTFit,"orange",2)
maxpoints(cross,crossTFit,"orange",2)
minpoints(cross,crossTFit,"orange",2)
legend(0.2,1,c("Egnethet med inverteringsfeil","Egnethet uten inverteringsfeil"),pch=c(1,2),col=c("blue","orange"))
dev.off()


postscript(file="crossRel.ps",onefile=F)
plot(crossRel,cross,xlab="Sannsynlighet for krysning",ylab="Pålitlighet",col="blue",pch=1,xlim=c(0.2,0.5), ylim=c(0,1.5),type="n")
avgline2(cross, crossRel,"red",1)
maxpoints(cross, crossRel,"red",1)
minpoints(cross, crossRel,"red",1)
avgline2(cross, crossTRel,"green",2)
maxpoints(cross, crossTRel,"green",2)
minpoints(cross, crossTRel,"green",2)
avgline2(cross, tmrR,"turquoise",3)
maxpoints(cross, tmrR,"turquoise",3)
minpoints(cross, tmrR,"turquoise",3)
avgline2(cross, enkelR,"purple",4)
maxpoints(cross, enkelR,"purple",4)
minpoints(cross, enkelR,"purple",4)
legend(0.2,1.5,c("Pålitlighet med inverteringsfeil","Pålitlighet uten inverteringsfeil","Pålitlighet av TMR-krets med inverteringsfeil","Pålitlighet av enkel multiplikator med inverteringsfeil"),pch=c(1,2,3,4),col=c("red","green","turquoise","purple"))
dev.off()


blokkFitness <- c(run20blokk$fitness, run40blokk$fitness,
                  run60blokk$fitness, run20ind$fitness,
                  run100blokk$fitness, run120blokk$fitness)
blokkTFitness <- c(run20blokk$t_fitness, run40blokk$t_fitness,
                   run60blokk$t_fitness, run20ind$t_fitness,
                   run100blokk$t_fitness, run120blokk$t_fitness)
blokkRel <- c(run20blokk$reliability, run40blokk$reliability,
              run60blokk$reliability, run20ind$reliability,
              run100blokk$reliability, run120blokk$reliability)
blokkTRel <- c(run20blokk$t_reliability, run40blokk$t_reliability,
               run60blokk$t_reliability, run20ind$t_reliability,
               run100blokk$t_reliability, run120blokk$t_reliability)

blokk <- c(20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
           40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 
           60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 
           80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 
           100, 100, 100, 100, 100, 100, 100, 100, 100, 100,
           120, 120, 120, 120, 120, 120, 120, 120, 120, 120)

tmrR <-
  c(0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093)

enkelR <- c(0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,)

postscript(file="blokkFit.ps",onefile=F)
plot(blokkFitness,blokk,xlab="Antall blokker",ylab="Egnethet",col="blue",pch=1,xlim=c(20,120), ylim=c(-7,2),type="n")
avgline2(blokk, blokkFitness,"blue",1)
maxpoints(blokk, blokkFitness,"blue",1)
minpoints(blokk, blokkFitness,"blue",1)
avgline2(blokk, blokkTFitness,"orange",2)
maxpoints(blokk, blokkTFitness,"orange",2)
minpoints(blokk, blokkTFitness,"orange",2)
legend(20,2,c("Egnethet med inverteringsfeil","Egnethet uten inverteringsfeil"),pch=c(1,2),col=c("blue","orange"))
dev.off()


postscript(file="blokkRel.ps",onefile=F)
plot(blokkRel,blokk,xlab="Antall blokker",ylab="Pålitlighet",col="blue",pch=1,xlim=c(20,120), ylim=c(0,1.5),type="n")
avgline2(blokk, blokkRel,"red",1)
maxpoints(blokk, blokkRel,"red",1)
minpoints(blokk, blokkRel,"red",1)
avgline2(blokk, blokkTRel,"green",2)
maxpoints(blokk, blokkTRel,"green",2)
minpoints(blokk, blokkTRel,"green",2)
avgline2(blokk, tmrR,"turquoise",3)
maxpoints(blokk, tmrR,"turquoise",3)
minpoints(blokk, tmrR,"turquoise",3)
avgline2(blokk, enkelR,"purple",4)
maxpoints(blokk, enkelR,"purple",4)
minpoints(blokk, enkelR,"purple",4)
legend(20,1.5,c("Pålitlighet med inverteringsfeil","Pålitlighet uten inverteringsfeil","Pålitlighet av TMR-krets med inverteringsfeil","Pålitlighet av enkel multiplikator med inverteringsfeil"),pch=c(1,2,3,4),col=c("red","green","turquoise","purple"))
dev.off()


mutFitness <- c(run01mut$fitness, run03mut$fitness,
                run20ind$fitness, run07mut$fitness, run09mut$fitness)
mutTFitness <- c(run01mut$t_fitness, run03mut$t_fitness,
                 run20ind$t_fitness, run07mut$t_fitness, run09mut$t_fitness)
mutRel <- c(run01mut$reliability, run03mut$reliability,
            run20ind$reliability, run07mut$reliability, run09mut$reliability)
mutTRel <- c(run01mut$t_reliability, run03mut$t_reliability,
             run20ind$t_reliability, run07mut$t_reliability, run09mut$t_reliability)

tmrR <-
  c(0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093,
    0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093, 0.72093)

enkelR <- c(0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0)

mutasjon <- c(0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01,
              0.03, 0.03, 0.03, 0.03, 0.03, 0.03, 0.03, 0.03,
              0.05, 0.05, 0.05, 0.05, 0.05, 0.05, 0.05, 0.05, 0.05, 0.05,
              0.07, 0.07, 0.07, 0.07, 0.07, 0.07, 0.07, 0.07,
              0.09, 0.09, 0.09, 0.09, 0.09, 0.09, 0.09, 0.09)


postscript(file="mutFit.ps",onefile=F)
plot(mutFitness,mutasjon, xlab="Sannsynlighet for mutasjon",ylab="Egnethet",col="blue",pch=1,xlim=c(0.01,0.09), ylim=c(-2.5,1),type="n")
avgline2(mutasjon, mutFitness,"blue",1)
maxpoints(mutasjon, mutFitness,"blue",1)
minpoints(mutasjon, mutFitness,"blue",1)
avgline2(mutasjon, mutTFitness,"orange",2)
maxpoints(mutasjon, mutTFitness,"orange",2)
minpoints(mutasjon, mutTFitness,"orange",2)
legend(0.01,1,c("Egnethet med inverteringsfeil","Egnethet uten inverteringsfeil"),pch=c(1,2),col=c("blue","orange"))
dev.off()


postscript(file="mutRel.ps",onefile=F)
plot(mutFitness,mutasjon,xlab="Sannsynlighet for mutasjon",ylab="Pålitlighet",col="blue",pch=1,xlim=c(0.01,0.09), ylim=c(0,1.5),type="n")
avgline2(mutasjon, mutRel,"red",1)
maxpoints(mutasjon, mutRel,"red",1)
minpoints(mutasjon, mutRel,"red",1)
avgline2(mutasjon, mutTRel,"green",2)
maxpoints(mutasjon, mutTRel,"green",2)
minpoints(mutasjon, mutTRel,"green",2)
avgline2(mutasjon, tmrR,"turquoise",3)
maxpoints(mutasjon, tmrR,"turquoise",3)
minpoints(mutasjon, tmrR,"turquoise",3)
avgline2(mutasjon, enkelR,"purple",4)
maxpoints(mutasjon, enkelR,"purple",4)
minpoints(mutasjon, enkelR,"purple",4)
legend(0.01,1.5,c("Pålitlighet med inverteringsfeil","Pålitlighet uten inverteringsfeil","Pålitlighet av TMR-krets med inverteringsfeil","Pålitlighet av enkel multiplikator med inverteringsfeil"),pch=c(1,2,3,4),col=c("red","green","turquoise","purple"))
dev.off()