class FU{
	friend std::ostream& operator<<(std::ostream&, const FU&);
	friend std::istream& operator>>(std::istream&, FU&);
	friend class Individual;
private:

	enum types{ NOT, NAND, NOR, AND, OR, VCC, GND,
		TYPECOUNT //This is not a type, but used to count the number of defined types
	};

	unsigned char pos;			// Number/Position of this FU
	//unsigned char input0;		// Connection to FU#
	//unsigned char input1;		// Connection to FU#
//	unsigned char input2;		// Connection to FU#
	unsigned char type;			// Type of gate
public:
	unsigned char input0;		// Connection to FU#
	unsigned char input1;		// Connection to FU#
	void setPos(unsigned int p){ pos=(unsigned char)p; }	// Set numer/position of FU
	void randomize();										// Randomize type and position
	void mutate();											// Perform a single mutation on one parameter
	float evaluate(float* inputs, Parameters*, bool fail);	// Evaluate the FU
	void setUsed(bool*, int& in0, int& in1);// sets the inputs to this block as used (in bool array)
  int getInput(unsigned char inputnumber);
  unsigned char isVCCGND(); // true if gate is VCC or GND
};
