#!/bin/bash

#
# extract31.sh [filnavn] [options]
#

filnavn=$1
options=$2

#Hvis -R er satt, startes en rekursiv prosedyre som starter opp
#dette programmet for hver subkatalog
if [[ $options = "-R" ]]
then
    for dir in *
    do
      if [ -d $dir ] 
      then
	  cd $dir
	  extract31.sh $filnavn -R
	  cd ..
      fi
    done
fi

#leser fra alle out_* filene og henter ut data og legger det
#i samme fil
if [ -e out_1 ]
then
    #Skriver ut overskriftene
    extract 3 > $filnavn.txt
    for file in out_*
    do
      #Skriver ut data
      extract $file 6 >> $filnavn.txt
      extract 3 >> $filnavn.txt
    done
fi
